jQuery(document).ready(function() {
	
	jQuery('.brw-dashboard-col-history:contains("Refunds"),.brw-dashboard-col-history:contains("Waive"),.brw-dashboard-col:contains("Claims returned")').remove();
	
	
	if(jQuery('h1:contains("Off-site | Central"),h1:contains("Aotearoa New Zealand Reference Collection"),h1:contains("Off-site Storage | Aotearoa New Zealand Reference"),h1:contains("Off-site Storage | General Stack"),h1:contains("Rare Books Collection"),h1:contains("Kohikohinga | Māori Reference Collection")').length > 0) {
		
		jQuery('#tabROLLHOURS, #tabHOLS, #tabGOOGLEMAP').hide();
		
	}
	
	
	jQuery('#divtabROLLHOURS').empty().append('<p>Find our opening hours for all branches below:<\/p><p><a href="https:\/\/www.wcl.govt.nz\/visit\/opening-hours\/" class="btn btn-primary">Opening Hours<\/a>');
	
	
	if(jQuery('.breadcrumb li.active:eq(0)[aria-current]').text().trim() == 'Current loans') {
	
		jQuery('.result-header-options .btn-toolbar .set-options .dropdown-menu:eq(0)').append('<a href="#" class="dropdown-item btn btn-outline-primary btn-sm me-lg-1" id="wclPrintButton"><i class="fa-solid fa-print mr-2"><\/i> Print my loans<\/a>');
		
		jQuery('#wclPrintButton').bind('click', function(e) {

			e.preventDefault();
			
			var currPage = jQuery('table:eq(0)');

			var nextPages = jQuery('a.page-link:not([aria-label])');

			var arr = [];

			function processLoans(obj) {
				
				var pageLoans = [];

				jQuery(obj).find('tbody tr').each(function() {
					
					var title = jQuery(this).find('td:eq(2) .card-title:eq(0)').text() + ' \/ ';
					
					var author = '';
					
					var auDate = jQuery(this).find('td:eq(2) .card-text span:eq(0)');
					
					if(auDate.length > 0) {
						
						author = jQuery(auDate).text();
						
					}
					
					title = title + author;
						
					var due = jQuery(this).find('td[data-caption="Due"]:eq(0)').text();
					
					
					var loanStatus = jQuery(this).find('td[data-caption="Due"]:eq(0)').next('td').find('span:eq(0)');
					
					loanStatus = loanStatus ? jQuery(loanStatus).text() : '';
					
					var loans = {
						'title' : title,
						'due' : due,
						'status' : loanStatus
					}
					
					pageLoans.push(loans);
					
				});
				
				return pageLoans;
				
			}

			arr.push(processLoans(currPage));

			var promises = [];

			jQuery(nextPages).each(function() {
				
				var addr = jQuery(this).attr('href');
				
				var request = jQuery.ajax({
					url: addr,
					context: document.body
				}).done(function(data) {
					
					arr.push(processLoans(data));
					
				});
				
				promises.push(request);
				
			});

			function printLoans(arrLoans) {
				
				arrLoans = arrLoans.flat();
				
				arrLoans.sort(function(a, b) {
					var c = new Date(a.due);
					var d = new Date(b.due);
					return c-d;
				});
				
					
				jQuery('body').append('<div class="modal fade" tabindex="-1" role="dialog" id="wcl-print"><div class="modal-dialog" role="document"><div class="modal-content"><div class="modal-header"><h5 class="modal-title">Print loans</h5><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><iframe id="wclPrintLoans" name="wclPrintLoans" class="mb-2 w-100"><\/iframe><button class="btn btn-primary" id="nowPrintWCL"><i class="fa-solid fa-print mr-2"><\/i> Print my loans<\/button></div><div class="modal-footer"><button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button></div></div></div></div>');

				
				var printHTML = '';
				
				for(var i=0; i<arrLoans.length; i++) {
					
					printHTML += '<tr><td style="padding-bottom: 0.5rem;">' + arrLoans[i].title + '<\/td><td style="text-wrap: nowrap; padding-bottom: 0.5rem;">' + arrLoans[i].due + '<\/td><td style="padding-bottom: 0.5rem;">' + arrLoans[i].status + '<\/td><\/tr>';	
					
				}
				
				printHTML = '<table style="font-family: Arial, Helvetica, sans-serif; text-align: left;"><thead><th scope="col" style="padding-bottom: 0.5rem;">Title<\/th><th scope="col" style="padding-bottom: 0.5rem;">Due Date<\/th><th scope="col" style="padding-bottom: 0.5rem;">Status<\/th><\/thead><tbody>' + printHTML + '<\/tbody><\/table>';
				
				jQuery('#wclPrintLoans').contents().find('body').html(printHTML).after(function() {
					
					var wclPrint = document.getElementById('wcl-print');
			
					var myModal = new bootstrap.Modal(wclPrint);
					
					jQuery('#nowPrintWCL').bind('click', function() {
						document.getElementById("wclPrintLoans").contentWindow.print();
					});
					
					myModal.show();
					
					wclPrint.addEventListener('hidden.bs.modal', function () {
						jQuery(wclPrint).remove();
					});
					
				});
				
				
			}

			Promise.all(promises).then(() => printLoans(arr));
			

		});
		
	}
	
	
	if(jQuery('.breadcrumb li.active:eq(0)[aria-current]').text().trim() == 'Reserves not yet available') {
		
		jQuery('.result-header-options .btn-toolbar .set-options .dropdown-menu:eq(0)').append('<a href="#" class="dropdown-item btn btn-outline-primary btn-sm me-lg-1" id="wclQueue"><i class="fa-solid fa-list-ol mr-2"></i><\/i> View Queue Position <i class="fa-solid fa-spinner fa-spin" style="display:none;"></i><\/a>');
		
		jQuery('#wclQueue').bind('click', function(e) {
			
			e.preventDefault();
			
			var queueButton = jQuery(this);
			
			jQuery(queueButton).find('.fa-spinner:eq(0)').show();

			var currPage = jQuery('table:eq(0)');

			var nextPages = jQuery('a.page-link:not([aria-label])');

			var arr = [];

			function processReserves(obj) {
				
				var pageReserves = [];

				jQuery(obj).find('tbody tr').each(function() {
					
					var title = jQuery(this).find('td:eq(2) .card-title:eq(0)').text() + ' \/ ';
					
					var author = '';
					
					var auDate = jQuery(this).find('td:eq(2) .card-text span:eq(0)');
					
					if(auDate.length > 0) {
						
						author = jQuery(auDate).text();
						
					}
					
					title = title + author;
						
					var rank = jQuery(this).find('td[data-caption="Rank"]:eq(0)').text();
					

				
					rank = rank.split(' of ');
					
					rank = rank[0];
					
					if(!rank) {
						
						rank = 0;
						
					}
				
					
					var reserves = {
						'title' : title,
						'rank' : rank
					}
					
					pageReserves.push(reserves);
					
				});
				
				return pageReserves;
				
			}

			arr.push(processReserves(currPage));

			var promises = [];

			jQuery(nextPages).each(function() {
				
				var addr = jQuery(this).attr('href');
				
				var request = jQuery.ajax({
					url: addr,
					context: document.body
				}).done(function(data) {
					
					arr.push(processReserves(data));
					
				});
				
				promises.push(request);
				
			});

			function rankReserves(arrReserves) {
				
				arrReserves = arrReserves.flat();

				arrReserves.sort(function(a, b) {
					var c = Number(a.rank);
					var d = Number(b.rank);
					return c-d;
				});

				
					
				jQuery('body').append('<div class="modal fade" tabindex="-1" role="dialog" id="wcl-reserves"><div class="modal-dialog" role="document"><div class="modal-content"><div class="modal-header"><h5 class="modal-title">Reserves by queue position</h5><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><div id="wclRankedReserves" class="mb-2" style="height: 500px; overflow-y: scroll;"><\/div></div><div class="modal-footer"><button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button></div></div></div></div>');

				
				var resHTML = '';
				
				for(var i=0; i<arrReserves.length; i++) {
					
					resHTML += '<tr><td>' + arrReserves[i].title + '<\/td><td class="text-center">' + (arrReserves[i].rank ? arrReserves[i].rank : 'Item in transit') + '<\/td><\/tr>';	
					
				}
				
				resHTML = '<table class="table"><thead><th scope="col">Title<\/th><th scope="col" class="text-nowrap">Queue Position<\/th><\/thead><tbody>' + resHTML + '<\/tbody><\/table>';
				
				jQuery('#wclRankedReserves').append(resHTML).after(function() {
					
					var wclRank = document.getElementById('wcl-reserves');
			
					var myModal = new bootstrap.Modal(wclRank);
					
					jQuery(queueButton).find('.fa-spinner:eq(0)').hide();
					
					myModal.show();
					
					wclRank.addEventListener('hidden.bs.modal', function () {
						jQuery(wclRank).remove();
					});
					
				});
				
				
			}

			Promise.all(promises).then(() => rankReserves(arr));
			
			
			
		});
		
	}

	
	
	
});